; Displayansteuerung ber Ringbuffer im SRAM

LcdInit:

	push work0
	ldi work0,1<<LcdD5
	out LcdPort,work0
	rcall LcdENpulse1
	rcall LcdENpulse2
	ldi work0,FUNCTION_SET
	rcall LcdCmd1
	ldi work0,FUNCTION_SET
	rcall LcdCmd2
	ldi work0,DISPLAY_SHIFT
	rcall LcdCmd1
	ldi work0,DISPLAY_SHIFT
	rcall LcdCmd2
	ldi work0,DISPLAY_CONTROL
	rcall LcdCmd1
	ldi work0,DISPLAY_CONTROL
	rcall LcdCmd2
	ldi work0,ENTRY_MODE_SET
	rcall LcdCmd1
	ldi work0,ENTRY_MODE_SET
	rcall LcdCmd2
	ldi work0,LCD_CLEAR_DISPLAY
	rcall LcdCmd1
	ldi work0,LCD_CLEAR_DISPLAY
	rcall LcdCmd2
	pop work0
	ret

LcdCmd1:
	rcall LcdCheckbusy1
	cbi LcdCtrlPort,LcdRS
	cbi LcdCtrlPort,LcdRW
	rjmp LcdSend1
LcdData1:
	rcall LcdCheckbusy1
	sbi LcdCtrlPort,LcdRS
	cbi LcdCtrlPort,LcdRW
LcdSend1:
	push work0				;save low nibble
	swap work0				;reverse nibble order
	andi work0,0x0F			;select upper nibble
	out LcdPort,work0
	rcall LcdENpulse1		;pulse out
	pop work0				;rescue lower nibble				
	andi work0,0x0F			;select lower nibble
	out LcdPort,work0		;set port
	rcall LcdENpulse1
	ret

LcdCmd2:
	rcall LcdCheckbusy2
	cbi LcdCtrlPort,LcdRS
	cbi LcdCtrlPort,LcdRW
	rjmp LcdSend2
LcdData2:
	rcall LcdCheckbusy2
	sbi LcdCtrlPort,LcdRS
	cbi LcdCtrlPort,LcdRW
LcdSend2:
	push work0				;save low nibble
	swap work0				;reverse nibble order
	andi work0,0x0F			;select upper nibble
	out LcdPort,work0
	rcall LcdENpulse2		;pulse out
	pop work0				;rescue lower nibble				
	andi work0,0x0F			;select lower nibble
	out LcdPort,work0		;set port
	rcall LcdENpulse2
	ret

LcdENpulse1:				;submit data to controller
	nop
	nop
	nop
	sbi LcdPort,LcdEN1
	nop
	nop
	nop
	cbi LcdPort,LcdEN1
	ret

LcdENpulse2:				;submit data to controller
	nop
	nop
	nop
	sbi LcdPort,LcdEN2
	nop
	nop
	nop
	cbi LcdPort,LcdEN2
	ret

LcdCheckbusy1:				;check the busy flag
	cbi LcdPort,LcdD7
	cbi LcdDir,LcdD7
	cbi LcdCtrlPort,LcdRS
	sbi LcdCtrlPort,LcdRW
	sbi LcdPort,LcdEN1
	nop
	nop
	nop
LcdCheckbusy1_:
	sbic LcdPin,LcdD7
	rjmp LcdCheckbusy1_
	nop
	cbi LcdPort,LcdEN1
	sbi LcdDir,LcdD7
	rcall LcdENpulse1
	ret

LcdCheckbusy2:				;check the busy flag
	cbi LcdPort,LcdD7 
	cbi LcdDir,LcdD7 
	cbi LcdCtrlPort,LcdRS	
	sbi LcdCtrlPort,LcdRW
	sbi LcdPort,LcdEN2
	nop
	nop
	nop
LcdCheckbusy2_:
	sbic LcdPin,LcdD7 
	rjmp LcdCheckbusy2_
	nop
	cbi LcdPort,LcdEN2
	sbi LcdDir,LcdD7 
	rcall LcdENpulse2
	ret

LcdWrite:					;writes whole Display from Ringbuffer
	push work0
	push work1				;save register data
	push xl
	push xh					;save Pointer
	ldi xl,low(LCD_START_ADRESS)
	ldi xh,high(LCD_START_ADRESS)
	ldi work0,LCD_SET_ADRESS + FIRST_LINE
	rcall LcdCmd1			;Select Display Adress 0x00
	ldi work1,LCD_CHARACTERS
LcdWrite0:
	ld work0,x+
	cpi work0,0
	brne _lcdw0
	ldi work0,0x20
_lcdw0:
	rcall LcdData1
	dec work1
	brne LcdWrite0
	
	ldi work0,LCD_SET_ADRESS + SECOND_LINE
	rcall LcdCmd1
	ldi work1,LCD_CHARACTERS
LcdWrite1:
	ld work0,x+
	cpi work0,0
	brne _lcdw1
	ldi work0,0x20
_lcdw1:
	rcall LcdData1
	dec work1
	brne LcdWrite1

	ldi work0,LCD_SET_ADRESS + FIRST_LINE
	rcall LcdCmd2			;Select Display Adress 0x00
	ldi work1,LCD_CHARACTERS
LcdWrite2:
	ld work0,x+
	cpi work0,0
	brne _lcdw2
	ldi work0,0x20
_lcdw2:
	rcall LcdData2
	dec work1
	brne LcdWrite2
	
	ldi work0,LCD_SET_ADRESS + SECOND_LINE
	rcall LcdCmd2
	ldi work1,LCD_CHARACTERS
LcdWrite3:
	ld work0,x+
	cpi work0,0
	brne _lcdw3
	ldi work0,0x20
_lcdw3:
	rcall LcdData2
	dec work1
	brne LcdWrite3

	pop xh
	pop xl

	pop work1
	pop work0

	cbr flags,1<<f_RefreshDisplay
	ret

LCDPutString:			;writes String from Flash(z) to Display Ringbuffer(x)

	push work0
	
_puts0:
	lpm
	mov work0,flashreg
	cpi work0,0
	breq _putsend
	st x+,work0
	adiw zl,1
	rjmp _puts0

_putsend:
	pop work0
	ret

cleardisplay:			;clears display lines 1 to 3
	cli
	push xl
	push xh
	push work0

	clr work0
	ldi xl,low(LCD_START_ADRESS)
	ldi xh,high(LCD_START_ADRESS)

_clr0:
	st x+,work0
	cpi xl,low(LCD_END_ADRESS-27)
	brne _clr0
	cpi xh,high(LCD_END_ADRESS-27)
	brne _clr0
	pop work0
	pop xh
	pop xl
	sei
	ret

